class
	S_NETDB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	getaddrinfo (a_name, a_service: CE_POINTER [INTEGER_8]; a_req: CE_POINTER [SD_ADDRINFO]; a_pai: CE_POINTER [CE_POINTER [SD_ADDRINFO]]): INTEGER_32
		do
			Result := c_getaddrinfo (a_name.c_pointer, a_service.c_pointer, a_req.c_pointer, a_pai.c_pointer)
		end

	c_getaddrinfo (a_name: POINTER; a_service: POINTER; a_req: POINTER; a_pai: POINTER): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return getaddrinfo($a_name, $a_service, $a_req, $a_pai);"
		end

	freeaddrinfo (a_ai: CE_POINTER [SD_ADDRINFO])
		do
			c_freeaddrinfo (a_ai.c_pointer)
		end

	c_freeaddrinfo (a_ai: POINTER)
		external
			"C inline use <libmongo.h>"
		alias
			"freeaddrinfo($a_ai);"
		end

	gai_strerror (a_ecode: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_gai_strerror (a_ecode))
		end

	c_gai_strerror (a_ecode: INTEGER_32): POINTER
		external
			"C inline use <libmongo.h>"
		alias
			"return (EIF_POINTER)gai_strerror($a_ecode);"
		end

end
