class
	S_SYS_SOCKET_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	socket (a_domain: INTEGER_32; a_type: INTEGER_32; a_protocol: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return socket($a_domain, $a_type, $a_protocol);"
		end

	connect (a_fd: INTEGER_32; a_addr: CE_POINTER [SD_SOCKADDR]; a_len: NATURAL_32): INTEGER_32
		do
			Result := c_connect (a_fd, a_addr.c_pointer, a_len)
		end

	c_connect (a_fd: INTEGER_32; a_addr: POINTER; a_len: NATURAL_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return connect($a_fd, $a_addr, $a_len);"
		end

	send (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_n: NATURAL_32; a_flags: INTEGER_32): INTEGER_32
		do
			Result := c_send (a_fd, a_buf.c_pointer, a_n, a_flags)
		end

	c_send (a_fd: INTEGER_32; a_buf: POINTER; a_n: NATURAL_32; a_flags: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return send($a_fd, $a_buf, $a_n, $a_flags);"
		end

	recv (a_fd: INTEGER_32; a_buf: CE_POINTER [ANY]; a_n: NATURAL_32; a_flags: INTEGER_32): INTEGER_32
		do
			Result := c_recv (a_fd, a_buf.c_pointer, a_n, a_flags)
		end

	c_recv (a_fd: INTEGER_32; a_buf: POINTER; a_n: NATURAL_32; a_flags: INTEGER_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return recv($a_fd, $a_buf, $a_n, $a_flags);"
		end

	setsockopt (a_fd, a_level, a_optname: INTEGER_32; a_optval: CE_POINTER [ANY]; a_optlen: NATURAL_32): INTEGER_32
		do
			Result := c_setsockopt (a_fd, a_level, a_optname, a_optval.c_pointer, a_optlen)
		end

	c_setsockopt (a_fd: INTEGER_32; a_level: INTEGER_32; a_optname: INTEGER_32; a_optval: POINTER; a_optlen: NATURAL_32): INTEGER_32
		external
			"C inline use <libmongo.h>"
		alias
			"return setsockopt($a_fd, $a_level, $a_optname, $a_optval, $a_optlen);"
		end

end
